#include "cv.h"
#include "highgui.h"
#include "string.h"
#include "cvblob.h"
#include "cvblob.cpp"
#include "cvlabel.cpp"
#include <opencv2\core\core.hpp>
#include <opencv2\highgui\highgui.hpp>
#include <iostream>


using namespace cvb;
typedef struct square {
	char nc;
	int ni;
	char pn;
}square;

double ctd_sqx[64], ctd_sqy[64];



//Initialize the chessboard
void init (square *board,int *occ_w,int *occ_bini) {
	int i,j;
	for(i=0;i<8;i++) {
		for(j=0;j<8;j++) {
			int a = (8*i) + j;
			board[a].nc = 'a' + i;
			board[a].ni = j+1;
			board[a].pn = ' ';
			if(i==1) {
				board[a].pn = 'p';
				occ_bini[a]=1;
			}
			else if(i==6) {
				board[a].pn = 'P';
				occ_w[a]=1;
			}
			else if(i==0) {
				if(j==0 || j==7){
					board[a].pn = 'e';
					occ_bini[a]=1;
				}
				else if(j==1 || j==6){
					board[a].pn = 'h';
					occ_bini[a]=1;
				}
				else if(j==2 || j==5){
					board[a].pn = 'c';
					occ_bini[a]=1;
				}
				else if(j==3){
					board[a].pn = 'k';
					occ_bini[a]=1;
				}
				else{
					board[a].pn = 'q';
					occ_bini[a]=1;
				}
			}
			else if(i==7) {
				if(j==0 || j==7){
					board[a].pn = 'E';
					occ_w[a]=1;
				}
				else if(j==1 || j==6){
					board[a].pn = 'H';
					occ_w[a]=1;
				}
				else if(j==2 || j==5){
					board[a].pn = 'C';
					occ_w[a]=1;
				}
				else if(j==3){
					board[a].pn = 'K';
					occ_w[a]=1;
				}
				else{
					board[a].pn = 'Q';
					occ_w[a]=1;}
			}
		}
	}
}


//Print the Board
void printboard(square *board) {
	int i,j;
	for(i=0;i<8;i++) {
		for(j=0;j<8;j++) {
			int a = (8*i) + j;
			printf("%c ",board[a].pn);
		}
		printf("\n");
	}
}
	

IplImage* GetThresholdedImage(IplImage* imgHSV){        
       IplImage* imgThresh=cvCreateImage(cvGetSize(imgHSV),IPL_DEPTH_8U, 1);
       cvInRangeS(imgHSV, cvScalar(0,0,125), cvScalar(180,150,256), imgThresh); 
       return imgThresh;
} 


void calculate_centroid_squares(double *centroid_x,double *centroid_y)
{
//    int c,d,i,j,k,m,l,mw,mb,lw,lb;
	  double *error=0;
 
   // input=cvLoadImage("binaryimage.jpg",1);
	
	cvWaitKey(0);
	


	CvCapture* capture =0;
	capture = cvCaptureFromCAM(0);
	if(!capture) {
		printf("Capture failure\n");
		return ;
	}
	
	cvNamedWindow("Video", CV_WINDOW_AUTOSIZE );
	cvNamedWindow("White Binary", CV_WINDOW_AUTOSIZE );
	cvNamedWindow("While Binary eroded", CV_WINDOW_AUTOSIZE );
	cvNamedWindow("Black Binary", CV_WINDOW_AUTOSIZE );
	cvNamedWindow("Black Binary eroded", CV_WINDOW_AUTOSIZE );
	//iterate through each frames of the video



	while(true) {
		IplImage* input;
		

		input = cvQueryFrame(capture);
		if(!input) 
		{

			printf("holaleoo \n"); 
			break;
		}

		input=cvCloneImage(input); 
		//cvSmooth(frame, frame, CV_GAUSSIAN,3,3);
		IplImage* imgHSV = cvCreateImage(cvGetSize(input), IPL_DEPTH_8U, 3);
		cvCvtColor(input, imgHSV, CV_BGR2HSV); //Change the color format from BGR to HSV
		IplImage* testw=cvCreateImage(cvGetSize(imgHSV),IPL_DEPTH_8U, 1);
		cvInRangeS(imgHSV, cvScalar(0,0,125), cvScalar(180,150,256), testw);

		IplImage* testb=cvCreateImage(cvGetSize(imgHSV),IPL_DEPTH_8U, 1);
		//cvInRangeS(imgHSV, cvScalar(0,125,0), cvScalar(180,256,125), testb);

		cvNot(testw,testb);

	//	cvShowImage("White Binary", testw);
	//	cvShowImage("Video", input);
	//	cvShowImage("Black Binary", input);

	/*	IplImage* grayImage = cvCreateImage( cvGetSize(input), IPL_DEPTH_8U, 3);
		IplImage* grayImage2 = cvCreateImage( cvGetSize(input), IPL_DEPTH_8U, 1);
		
		cvCvtColor(testw,grayImage,CV_HSV2RGB);
		cvCvtColor(grayImage,grayImage2,CV_RGB2GRAY);
		//cvThreshold(frame,destframe,65,250,CV_THRESH_BINARY_INV);
		cvThreshold(grayImage,grayImage,20,255,CV_THRESH_BINARY);*/

		//cvSmooth(grayImage,grayImage,CV_MEDIAN,8,8);

		//cvDilate(grayImage, grayImage, 0, 0);
		cvErode(testw, testw, 0, 3);
		cvErode(testb, testb, 0, 2);
		//cvCopy(grayImage,testw);



	//	cvSmooth(testw, testw, CV_GAUSSIAN,3,3); //smooth the binary image using Gaussian kernel
		
		//cvNot(imgThresh,imgThresh);
	

		/*if(x == 100) {
			cvSaveImage("binaryimage.jpg",imgThresh);
		}*/
		
		
		
/*	CvMat *testw_mat = cvCreateMat(testw->height,testw->width,CV_32FC3 );
		cv::Mat testw_mat2 = testw_mat;
		cvConvert(testw,&testw_mat2);
		cvErode(&testw_mat2,&testw_mat2,NULL,1);
		cvConvert(&testw_mat2,testw);*/
		
		cvShowImage("White Binary eroded", testw);
	//	cvShowImage("Black Binary eroded", testb);
		cvWaitKey(33);

		//BLOB operation starts

			  IplImage* labelImg_white;
              IplImage* imgOut_white;
              imgOut_white=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
              labelImg_white=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
              CvBlobs blobs_white;
			
			  cvLabel(testw, labelImg_white, blobs_white);		
              cvFilterByArea(blobs_white,1000,6000); 
			  cvRenderBlobs(labelImg_white, blobs_white, testw, imgOut_white,CV_BLOB_RENDER_COLOR); //give each blob a colour
			  cvRenderBlobs(labelImg_white, blobs_white, testw, imgOut_white,CV_BLOB_RENDER_CENTROID);
              cvNamedWindow("blobs-white", 1);
			  cvShowImage("blobs-white",imgOut_white);
			  cvWaitKey(33);

			  //For Black
			  IplImage* labelImg_black;
              IplImage* imgOut_black;
              imgOut_black=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
              labelImg_black=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
              CvBlobs blobs_black;
			
			  cvLabel(testb, labelImg_black, blobs_black);		
              cvFilterByArea(blobs_black,1000,10000); 
			  cvRenderBlobs(labelImg_black, blobs_black, testb, imgOut_black,CV_BLOB_RENDER_COLOR); //give each blob a colour
			  cvRenderBlobs(labelImg_black, blobs_black, testb, imgOut_black,CV_BLOB_RENDER_CENTROID);
              cvNamedWindow("blobs-black", 1);
			  cvShowImage("blobs-black",imgOut_black);
			  cvWaitKey(33);
			  cvSaveImage("White Blobs.jpg",imgOut_white);
			  cvSaveImage("Black Blobs.jpg",imgOut_black);

			  //count no. of blobs and store centroid
			  int count_blobs_white=0;
			
			  
			  
			  //for white
			  for (CvBlobs::const_iterator it=blobs_white.begin(); it!=blobs_white.end(); ++it)
			  {
				//  cout << "Blob #" << it->second->label << ": Area=" << it->second->area << ", Centroid=(" << it->second->centroid.x << ", " << it->second->centroid.y << ")" << endl;
				  centroid_x[2*count_blobs_white]=it->second->centroid.x;
				  
				  centroid_y[2*count_blobs_white]=it->second->centroid.y;
				  count_blobs_white++;

			  }
			
			  //for black
			  int count_blobs_black=0;

			  for (CvBlobs::const_iterator it=blobs_black.begin(); it!=blobs_black.end(); ++it)
			  {
				//  cout << "Blob #" << it->second->label << ": Area=" << it->second->area << ", Centroid=(" << it->second->centroid.x << ", " << it->second->centroid.y << ")" << endl;
				  centroid_x[2*count_blobs_black+1]=it->second->centroid.x;
				  centroid_y[2*count_blobs_black+1]=it->second->centroid.y;
				  count_blobs_black++;

			  }

			    if (count_blobs_white==32 && count_blobs_black==32)
				 break;
	
			  cvWaitKey(50);


		//Clean up used images
		cvReleaseImage(&input);
		cvReleaseImage(&imgHSV);
		cvReleaseImage(&testw);
		cvReleaseImage(&testb);
		cvReleaseImage(&imgOut_white);
		cvReleaseImage(&labelImg_white);
		cvReleaseImage(&imgOut_black);
		cvReleaseImage(&labelImg_black);
		cvReleaseBlobs(blobs_white);
		cvReleaseBlobs(blobs_black);
		
		//Wait 50mS
		int c = cvWaitKey(10);
		//If 'ESC' is pressed, break the loop
		if((char)c==27 ) break;
	}
	cvDestroyAllWindows() ;
	cvReleaseCapture(&capture);
	return ;
}



//Find Centroid of pieces
void ctd_pieces(double *centroid_x, double *centroid_y, int no_pieces, int select)
{
	CvCapture* capture =0;
	capture = cvCaptureFromCAM(0);
	if(!capture) {
		printf("Capture failure\n");
		return ;
	}

	cvNamedWindow("Black pieces",1);
	

	while(true) {
		IplImage* input;
		

		input = cvQueryFrame(capture);
		if(!input) 
		{

			printf("holaleoo \n"); 
			break;
		}

		IplImage* imgHSV = cvCreateImage(cvGetSize(input), IPL_DEPTH_8U, 3);
		IplImage* testb=cvCreateImage(cvGetSize(imgHSV),IPL_DEPTH_8U, 1);
		cvCvtColor(input, imgHSV, CV_BGR2HSV); //Change the color format from BGR to HSV
		
		//for black
		if (select==0)
		{
			input=cvCloneImage(input); 
			//cvSmooth(frame, frame, CV_GAUSSIAN,3,3);
			cvInRangeS(imgHSV, cvScalar(0,0,0), cvScalar(255,255,50), testb);
		}

		//for white
		else
		{
			input=cvCloneImage(input); 
			//cvSmooth(frame, frame, CV_GAUSSIAN,3,3);
			cvInRangeS(imgHSV, cvScalar(0,0,210), cvScalar(255,20,256), testb);
		}

	//	cvDilate(testb, testb, 0, 1);

		cvShowImage("Black pieces", testb);
		
		
		//BLOB operation starts
			  IplImage* labelImg_black;
              IplImage* imgOut_black;
              imgOut_black=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
              labelImg_black=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
              CvBlobs blobs_black;
			
			  cvLabel(testb, labelImg_black, blobs_black);		
              cvFilterByArea(blobs_black,100,3000); 
			  cvRenderBlobs(labelImg_black, blobs_black, testb, imgOut_black,CV_BLOB_RENDER_COLOR); //give each blob a colour
			  cvRenderBlobs(labelImg_black, blobs_black, testb, imgOut_black,CV_BLOB_RENDER_CENTROID);
              cvNamedWindow("blobs-black", 1);
			  cvShowImage("blobs-black",imgOut_black);
			  cvWaitKey(33);
			  cvSaveImage("blackblobs.jpg",imgOut_black);

			   //for black
			  int count_blobs_black=0;

			  for (CvBlobs::const_iterator it=blobs_black.begin(); it!=blobs_black.end(); ++it) {
				//  cout << "Blob #" << it->second->label << ": Area=" << it->second->area << ", Centroid=(" << it->second->centroid.x << ", " << it->second->centroid.y << ")" << endl;
				  centroid_x[count_blobs_black]=it->second->centroid.x;
				  centroid_y[count_blobs_black]=it->second->centroid.y;
				  count_blobs_black++;
			  }
			  if (count_blobs_black==no_pieces)
				// {for(int i=0;i<16;i++)
				//	printf("for white blob %d C(%lf,%lf)\n ", i,centroid_x[i],centroid_y[i]);
					 break;
				 
			  cvWaitKey(50);


		//Clean up used images
		cvReleaseImage(&input);
		cvReleaseImage(&imgHSV);
		cvReleaseImage(&testb);
		cvReleaseImage(&imgOut_black);
		cvReleaseImage(&labelImg_black);
		cvReleaseBlobs(blobs_black);
		
		//Wait 50mS
		int c = cvWaitKey(10);
		//If 'ESC' is pressed, break the loop
		if((char)c==27 ) break;
	}
	cvDestroyAllWindows() ;
	cvReleaseCapture(&capture);
	return ;



}



//Sort Centroids acccording to rows then columns
void sortcentroid(double *cx,double *cy) {
	int i,j,k;
	int a,b;
	double tempx,tempy;
	for(i=0;i<64;i++) {
		for(j=i;j<64;j++) {
			if(cx[i]>cx[j]) {
				tempx = cx[i];
				tempy = cy[i];
				cx[i] = cx[j];
				cy[i] = cy[j];
				cx[j] = tempx;
				cy[j] = tempy;
			}
		}
	}
	
	for(i=0;i<8;i++) {
		for(j=0;j<8;j++) {
			for(k=0;k<8;k++) {
				a = (i*8)+j;
				b = (i*8)+k;
				if(cy[a]>cy[b]) {
					tempx = cx[a];
					tempy = cy[a];
					cx[a] = cx[b];
					cy[a] = cy[b];
					cx[b] = tempx;
					cy[b] = tempy;
				}
			}
		}
	}
}


IplImage *temp;

void my_mouse_callback( int event, int x, int y, int flags, void* param)
{
   uchar *ptemp  =  (uchar*)temp->imageData;
printf("\nx=%d(%d)\t y=%d(%d)\t\th=%d \ts=%d \tv=%d\n",x,temp->width,y,temp->height,ptemp[y*temp->widthStep + x*temp->nChannels+0],ptemp[y*temp->widthStep + x*temp->nChannels+1],ptemp[y*temp->widthStep + x*temp->nChannels+2]);
} 


void caliberate(){
	
	int c;//to store ascii value of key pressed
    int i,j,h,s,v;
    CvCapture *capture=cvCreateCameraCapture(0);//initiate camera 
    //because of recursively updating frame , here we dont need to wait for camera as for some ms frame will be black and then as camera starts , frame will update and shaw image
    IplImage *frame;
    
     IplImage* outputred;
   IplImage* outputone;
   IplImage* outputtwo;
  // IplImage* outputblue;
   IplImage* outputwhite;
  // IplImage* outputorange;
   
    uchar *ptemp;
   // uchar *poutputorange;
    uchar *poutputred;
    uchar *poutputwhite;
   // uchar *poutputblue;
    uchar *poutputone;
    uchar *poutputtwo;
      
    if(capture!=NULL)
    {
                     frame=cvQueryFrame(capture);//take current image in camera and give it to frame pointer
                     cvNamedWindow("img");
                     while(1)
                     {
                             
                             cvShowImage("img",frame);
                            frame=cvQueryFrame(capture);
                            temp=cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,3);
                            cvCvtColor(frame,temp,CV_BGR2HSV);
                            //frame rate time period (if not given system will hang as system processing speed is very fast
                           // cvNamedWindow("output",1);
                            //cvShowImage("output",temp);
                            cvSetMouseCallback("img", my_mouse_callback, NULL);
                            c=cvWaitKey(1);
                            outputred=cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
     outputone=cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
      outputtwo=cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
     //  outputblue=cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
        outputwhite=cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
     //    outputorange=cvCreateImage(cvGetSize(frame),IPL_DEPTH_8U,1);
    
    cvCvtColor(frame,temp,CV_BGR2HSV);
    ptemp  =  (uchar*)temp->imageData;
    poutputone  =  (uchar*)outputone->imageData;
    poutputtwo  =  (uchar*)outputtwo->imageData;
   // poutputblue  =  (uchar*)outputblue->imageData;
    poutputwhite  =  (uchar*)outputwhite->imageData;
    poutputred  =  (uchar*)outputred->imageData;
  //  poutputorange  =  (uchar*)outputorange->imageData;
    
     for(i=0;i<frame->height;i++)
            for(j=0;j<frame->width;j++)
            {
                                       h=ptemp[i*temp->widthStep + j*temp->nChannels+0];
                                       s=ptemp[i*temp->widthStep + j*temp->nChannels+1];
                                       v=ptemp[i*temp->widthStep + j*temp->nChannels+2];
                                       
                                         if((h>=157&&h<=178)&&s>=110 && s<=255 &&v>=90)//red
                                                                         poutputred[i*outputred->widthStep + j]=255;
                                       else
                                                                          poutputred[i*outputred->widthStep + j]=0;
                                       if((h==0 && s==0 &&v<150 && v>9)||(h>=25 &&h<=110 && s>=20&&s<=200&& v>=13 && v<=120))//one
                                                                         poutputone[i*outputone->widthStep + j]=255;
                                       else
                                                                          poutputone[i*outputone->widthStep + j]=0;
                                  
                               /*       if((h>=145 &&h<=160)&&s>=175 && s<=255 && v>=80 && v<=150)//one
                                                                         poutputone[i*outputone->widthStep + j]=255;
                                       else
                                                                          poutputone[i*outputone->widthStep + j]=0;
                                 */                                         
                                       if(h>=110 &&h<=153&&s>=90&&v>=7 && v<=150)//two
                                                                         poutputtwo[i*outputtwo->widthStep + j]=255;
                                       else
                                                                          poutputtwo[i*outputtwo->widthStep + j]=0;
                                          if( (h==0 && s==0 && v>=250) || (((h>=0 && h<=30)) && s>=50&&s<=200&&v>=110) )//white 
                                                                         poutputwhite[i*outputwhite->widthStep + j]=255;
                                       else
                                                                          poutputwhite[i*outputwhite->widthStep + j]=0;
                                   
                                                                          
            }
     
    //cvNamedWindow("output",1);
    cvNamedWindow("outputred",1);
    cvNamedWindow("outputone",1);
    cvNamedWindow("outputtwo",1);
  //  cvNamedWindow("outputblue",1);
    cvNamedWindow("outputwhite",1);
    //cvNamedWindow("outputorange",1);

    //cvShowImage("output",temp);
    cvShowImage("outputred",outputred);
    cvShowImage("outputone",outputone);
    cvShowImage("outputtwo",outputtwo);
   // cvShowImage("outputblue",outputblue);
    cvShowImage("outputwhite",outputwhite);
   // cvShowImage("outputorange",outputorange);
    cvWaitKey(1);
 /*   imgOutred=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
    labelImgred=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
    CvBlobs blobsred;
    cvLabel(outputred, labelImgred, blobsred);
    cvRenderBlobs(labelImgred, blobsred, input, imgOutred);
    cvFilterByArea(blobsred,PIXEL_MIN,PIXEL_MAX);

    imgOutone=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
    labelImgone=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
    CvBlobs blobsone;
    cvLabel(outputone, labelImgone, blobsone);
    cvRenderBlobs(labelImgone, blobsone, input, imgOutone);
    cvFilterByArea(blobsone,PIXEL_MIN,PIXEL_MAX);

    imgOuttwo=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
    labelImgtwo=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
    CvBlobs blobstwo;
    cvLabel(outputtwo, labelImgtwo, blobstwo);
    cvRenderBlobs(labelImgtwo, blobstwo, input, imgOuttwo);
    cvFilterByArea(blobstwo,PIXEL_MIN,PIXEL_MAX);

    imgOutblue=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
    labelImgblue=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
    CvBlobs blobsblue;
    cvLabel(outputblue, labelImgblue, blobsblue);
    cvRenderBlobs(labelImgblue, blobsblue, input, imgOutblue);
    cvFilterByArea(blobsblue,PIXEL_MIN,PIXEL_MAX);
    
    imgOutwhite=cvCreateImage(cvGetSize(input),IPL_DEPTH_8U,3);
    labelImgwhite=cvCreateImage(cvGetSize(input),IPL_DEPTH_LABEL,1);
    CvBlobs blobswhite;
    cvLabel(outputwhite, labelImgwhite, blobswhite);
    cvRenderBlobs(labelImgwhite, blobswhite, input, imgOutwhite);
    cvFilterByArea(blobswhite,PIXEL_MINWHITE,PIXEL_MAX);
    
   */ 
    
    
    
    
    cvReleaseImage( &outputred ); 
    cvReleaseImage( &outputone ); 
    cvReleaseImage( &outputtwo ); 
    //cvReleaseImage( &outputblue ); 
    cvReleaseImage( &outputwhite ); 
    //cvReleaseImage( &outputorange );
                            cvReleaseImage(&temp ); 
                            //cvDestroyWindow( "output" );
                            if(c>0&&c<255)
                                     {
                                            cvDestroyWindow( "img" );
                                            cvReleaseImage( &frame ); 
                                            cvReleaseCapture(&capture);
     //                                       cvDestroyWindow( "outputred" );
                                            //cvDestroyWindow( "output" );
  //  cvDestroyWindow( "outputone" );
   // cvDestroyWindow( "outputtwo" );
    //cvDestroyWindow( "outputblue" );
   // cvDestroyWindow( "outputwhite" );
    //cvDestroyWindow( "outputorange" );
    
    cvReleaseImage( &outputred ); 
    cvReleaseImage( &outputone ); 
    cvReleaseImage( &outputtwo ); 
    //cvReleaseImage( &outputblue ); 
    cvReleaseImage( &outputwhite ); 
    //cvReleaseImage( &outputorange ); 
     
    
                                            return ;
                                     }
                     }
    }
}


void check_occ(int *occ, int sel, int count){
	double ctd_pcx[16],ctd_pcy[16];
	int i,j;
	for(i=0;i<64;i++)
		occ[i]=0;
	double side=abs(ctd_sqy[1]-ctd_sqy[0]);
	double dist=(side/2)*(side/2);
	double d;
	int least=0;
	if (sel==0)
		ctd_pieces(ctd_pcx,ctd_pcy,count,0);
	
	else if(sel==1)
		ctd_pieces(ctd_pcx,ctd_pcy,count,1);

	for(i=0;i<count; i++){
		for(j=0;j<64; j++){
			double x=(ctd_pcx[i]-ctd_sqx[j]);
			double y= (ctd_pcy[i]-ctd_sqy[j]);
			d=(x*x)+(y*y);
			if(d<dist){
				dist=d;
				least=j;
			}
		}
		occ[least]=1;
		dist=(side/2);
	}
}


void calmove(int *ini,int *fin, int *move){
	int dif[64],i;
	for(i=0;i<64;i++){
		dif[i]=ini[i]-fin[i];
		if(dif[i]==1)
			move[0]=i;
		else if(dif[i]==(-1))
			move[1]=i;
	}
}


void boardupdate(square *board, int *move){
	board[move[1]].pn = board[move[0]].pn;
	board[move[0]].pn = ' ';
}
	
	







int main(){
	int a,occ_w[64],occ_bini[64],occ_bfin[64],tmp,i;				 //a to check input, occ to check occupancy of squares
	int count_w=16; 
	int count_b=16;
	int move[2];
	square board[64];

	calculate_centroid_squares(ctd_sqx, ctd_sqy);			//First calculate centroid of squares and store them
	sortcentroid(ctd_sqx,ctd_sqy);							//Sort the centroid and number the squares
	for(int i=0;i<64;i++){
		printf("%lf	%lf\n",ctd_sqx[i],ctd_sqy[i]);
	}
	init(board,occ_w,occ_bini);											//Initialize
					
	printf("Board has been intialised, please put the pieces\n Press 1 to continue\n");
	scanf("%d\n",&a);
	printf("Board has been intialised, please put the pieces\n Press 1 to continue\n");
	printboard(board);	
	if (a!=1)
		return -1;


	double ctd_bpcx[16],ctd_bpcy[16],ctd_wpcx[16],ctd_wpcy[16];
	
	ctd_pieces(ctd_bpcx,ctd_bpcy,count_b,0);
	for(int i=0;i<16;i++)
		printf("for black blob %d C(%lf,%lf)\n ", i,ctd_bpcx[i],ctd_bpcy[i]);
	scanf("%d", &a);

	ctd_pieces(ctd_wpcx,ctd_wpcy,count_w,1);
	for(i=0;i<16;i++)
		printf("for white blob %d C(%lf,%lf)\n", i,ctd_wpcx[i],ctd_wpcy[i]);
	
	//caliberate();

	
		
	while(1)
	{
		printf("entering while\n");
		a=0;
		printf("Press 1 when you have finished your move\n");
		scanf("%d\n",&a);
		check_occ(occ_w,1,count_w); 
		scanf("%d",&a);
		printf("after checking white \n");// Check which squares white pieces occupy
		for(i=0;i<64;i++){
			printf("%d- ", occ_w[i]);
		}
		printf("\n For black pieces index is:\n ");
		
		check_occ(occ_bfin,0,count_b);
		for(i=0;i<64;i++){
			printf("%d- ", occ_bfin[i]);
		}
		printf("\n ");
		printf("after checking black \n");
		calmove(occ_bini,occ_bfin,move);
		printf("after caculating move from %d to %d \n",move[0],move[1]);
		
		/*if(occ_w[move[1]]==1){
			printf("entering if \n");
			occ_w[move[1]]=0;
			count_w=count_w-1;
		}*/

		printf("Your move- from %c%d to %c%d\n", board[move[0]].nc,board[move[0]].ni,board[move[1]].nc,board[move[1]].ni);
		boardupdate(board,move);
		printboard(board);
		for(i=1;i<64;i++)
			occ_bini[i]=occ_bfin[i];
		printf("exiting \n");
	}
}