/*
 * 
 *  dynamic linker command file
 *  generated: Fri Apr 12 22:05:29 2013

 *  kernel   : brickOS
 *  app start: 0xae6c
 * 
 *  BrickOS for LEGO(R) Mindstorms(TM)
 *  Originally: legOS - the independent LEGO Mindstorms OS
 *              (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x2e6c
  ram   : o = 0xae6c, l = 0x5090
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x001a ;
    _mm_try_join = 0x0120 ;
    _mm_defrag = 0x015e ;
    _mm_update_first_free = 0x019c ;
    _mm_init = 0x01c2 ;
    _malloc = 0x0226 ;
    _free = 0x02cc ;
    _calloc = 0x02f6 ;
    _mm_reaper = 0x033e ;
    _mm_free_mem = 0x036c ;
    _clock_handler = 0x03aa ;
    _subsystem_handler = 0x03ce ;
    _task_switch_handler = 0x0430 ;
    _systime_tm_return = 0x044a ;
    _systime_init = 0x045e ;
    _systime_shutdown = 0x04d6 ;
    _systime_set_switcher = 0x04e8 ;
    _systime_set_timeslice = 0x04ee ;
    _get_system_up_time = 0x050c ;
    _tm_switcher = 0x0522 ;
    _tm_scheduler = 0x053e ;
    _yield = 0x06da ;
    _tm_man_task = 0x06f8 ;
    _tm_battery_task = 0x073c ;
    _tm_init = 0x0784 ;
    _tm_start = 0x07f2 ;
    _execi = 0x0804 ;
    _exit = 0x09a4 ;
    _wait_event = 0x09c6 ;
    _msleep = 0x0a70 ;
    _sleep = 0x0aac ;
    _shutdown_task = 0x0ad0 ;
    _shutdown_tasks = 0x0adc ;
    _kill = 0x0b2c ;
    _killall = 0x0b68 ;
    _sem_event_wait = 0x0bea ;
    _sem_wait = 0x0c04 ;
    _sem_timedwait = 0x0c78 ;
    _sem_trywait = 0x0cc0 ;
    _delay = 0x0cd8 ;
    _cputc_native = 0x0cf8 ;
    _cputc_native_0 = 0x0d26 ;
    _cputc_native_1 = 0x0d5a ;
    _cputc_native_2 = 0x0d90 ;
    _cputc_native_3 = 0x0dca ;
    _cputc_native_4 = 0x0e06 ;
    _cputc_native_5 = 0x0e42 ;
    _cputw = 0x0e4e ;
    _cputs = 0x0e92 ;
    _cls = 0x0eda ;
    _lcd_number = 0x0ee2 ;
    _lcd_refresh_next_byte = 0x0f82 ;
    _lcd_refresh = 0x0fe2 ;
    _lcd_power_on = 0x1012 ;
    _lcd_power_off = 0x1024 ;
    _lcd_init = 0x1040 ;
    _txend_handler = 0x1154 ;
    _lnp_logical_shutdown = 0x119a ;
    _lnp_logical_init = 0x11ba ;
    _lnp_logical_write = 0x1280 ;
    _lnp_integrity_write = 0x1346 ;
    _lnp_addressing_write = 0x13a8 ;
    _lnp_receive_packet = 0x143c ;
    _lnp_integrity_byte = 0x14ba ;
    _lnp_integrity_reset = 0x1696 ;
    _lnp_timeout_reset = 0x16d2 ;
    _lnp_init = 0x16e0 ;
    _msg_received = 0x1702 ;
    _send_msg = 0x1768 ;
    _lnp_integrity_active = 0x17c6 ;
    _lnp_timeout_set = 0x17d2 ;
    _lr_getdata = 0x17dc ;
    _lr_process = 0x1804 ;
    _lr_waitdata = 0x1878 ;
    _lr_thread = 0x18ae ;
    _lr_init = 0x18e2 ;
    _lr_startup = 0x18ec ;
    _lr_shutdown = 0x1930 ;
    _program_valid = 0x1944 ;
    _program_stop = 0x1cfe ;
    _key_handler = 0x1d7a ;
    _lrkey_handler = 0x2026 ;
    _program_init = 0x224e ;
    _program_shutdown = 0x22ae ;
    _vis_handler = 0x22bc ;
    _get_battery_mv = 0x2326 ;
    _shutoff_restart = 0x2350 ;
    _shutoff_init = 0x2360 ;
    _autoshutoff_check = 0x236c ;
    _dkey_handler = 0x23ac ;
    _dkey_pressed = 0x23ea ;
    _dkey_released = 0x240c ;
    _getchar = 0x242c ;
    _dm_init = 0x2456 ;
    _dm_shutdown = 0x245a ;
    _motor_a_dir = 0x247c ;
    _motor_b_dir = 0x24ba ;
    _motor_c_dir = 0x24fc ;
    _ds_rotation_set = 0x253c ;
    _ds_rotation_handler = 0x2590 ;
    _ds_init = 0x2688 ;
    _ds_shutdown = 0x26be ;
    _dsound_handler = 0x26d6 ;
    _dsound_init = 0x27da ;
    _dsound_shutdown = 0x27f2 ;
    _dsound_stop = 0x27f6 ;
    _dsound_finished = 0x2816 ;
    _atomic_inc = 0x2830 ;
    _atomic_dec = 0x283e ;
    _locked_check_and_increment = 0x284c ;
    _wait_critical_section = 0x2886 ;
    _enter_critical_section = 0x28a8 ;
    _setjmp = 0x28d6 ;
    _longjmp = 0x28f2 ;
    _memcpy = 0x2906 ;
    _memset = 0x2918 ;
    ___mulhi3 = 0x2926 ;
    ___udivhi3 = 0x2936 ;
    ___mulsi3 = 0x2948 ;
    ___divsi3 = 0x2964 ;
    _hex_display_codes = 0x29ae ;
    _ascii_display_codes = 0x29be ;
    _lnp_rcx_header = 0x2a50 ;
    _lnp_rcx_remote_op = 0x2a52 ;
    _lnp_rcx_msg_op = 0x2a54 ;
    _min_length = 0x2a7e ;
    _dm_a_pattern = 0x2aae ;
    _dm_b_pattern = 0x2ab2 ;
    _dm_c_pattern = 0x2ab6 ;
    _firmware_string = 0x2b98 ;
    _etext = 0x2b98 ;
    _lcd_refresh_period = 0x2b9a ;
    _lnp_hostaddr = 0x2b9c ;
    _lnp_timeout = 0x2b9e ;
    _lr_dataready = 0x2ba0 ;
    _vis_refresh_counter = 0x2ba2 ;
    _vis_refresh_period = 0x2ba3 ;
    _battery_refresh_counter = 0x2ba4 ;
    _battery_refresh_period = 0x2ba6 ;
    _auto_shutoff_counter = 0x2ba8 ;
    _auto_shutoff_period = 0x2baa ;
    _auto_shutoff_secs = 0x2bac ;
    _auto_shutoff_elapsed = 0x2bae ;
    _idle_powerdown = 0x2bb0 ;
    _dsound_system_sounds = 0x2bb2 ;
    __edata = 0x2bb4 ;
    _bss_start = 0x2bc0 ;
    _mm_first_free = 0x2daa ;
    _tm_timeslice = 0x2dac ;
    _tm_current_slice = 0x2dad ;
    _tm_switcher_vector = 0x2dae ;
    _sys_time = 0x2db0 ;
    _ctid = 0x2dc0 ;
    _td_single = 0x2dd0 ;
    _nb_tasks = 0x2de4 ;
    _priority_head = 0x2de6 ;
    _nb_system_tasks = 0x2de8 ;
    _lcd_byte_counter = 0x2dea ;
    _lcd_refresh_counter = 0x2deb ;
    _tx_state = 0x2dec ;
    _lnp_rcx_checksum = 0x2df0 ;
    _lnp_integrity_handler = 0x2df2 ;
    _lnp_rcx_message = 0x2df4 ;
    _lnp_rcx_temp1 = 0x2df5 ;
    _lnp_timeout_counter = 0x2df6 ;
    _lnp_addressing_handler = 0x2e00 ;
    _lnp_remote_handler = 0x2e20 ;
    _lnp_integrity_state = 0x2e22 ;
    _lnp_rcx_temp0 = 0x2e24 ;
    _lr_curkeys = 0x2e28 ;
    _lr_data = 0x2e2a ;
    _EventType = 0x2e2c ;
    _lr_handler = 0x2e2e ;
    _lr_tid = 0x2e30 ;
    _lr_timeoff = 0x2e34 ;
    _packet_len = 0x2e38 ;
    _cprog = 0x2e3a ;
    _packet_src = 0x2e3c ;
    _dkey_timer = 0x2e3e ;
    _dkey = 0x2e3f ;
    _dkey_multi = 0x2e40 ;
    _dm_a = 0x2e44 ;
    _dm_b = 0x2e48 ;
    _dm_c = 0x2e4c ;
    _ds_rotation = 0x2e50 ;
    _ds_channel = 0x2e51 ;
    _ds_rotations = 0x2e54 ;
    _ds_activation = 0x2e5a ;
    _dsound_next_note = 0x2e5c ;
    _dsound_internote_ms = 0x2e5e ;
    _dsound_16th_ms = 0x2e60 ;
    _dsound_next_time = 0x2e64 ;
    _kernel_critsec_count = 0x2e68 ;
    _end = 0x2e6a ;
    _mm_start = 0x2e6a ;
    _dm_handler = 0x7002 ;
    ___etext_hi = 0x704a ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _WDT_CSR = 0xa8 ;
    _WDT_CNT = 0xa9 ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
